from collections.abc import Awaitable, Callable, Sequence
from typing import Any

from temporalio import workflow

from csirtmu.beta_temporal.commons.actions import RTCommonActions
from csirtmu.beta_temporal.commons.actions.temporal_common_actions import TemporalCommonActions
from csirtmu.beta_temporal.commons.conditions import CommonConditions
from csirtmu.beta_temporal.config import AppConfig, Config
from csirtmu.beta_temporal.constants import WorkflowReference
from csirtmu.beta_temporal.external_services.rt.client import RTClient
from csirtmu.beta_temporal.external_services.rt.structs import TransactionStruct
from csirtmu.beta_temporal.workflows.logging import LoggedWorkflow


class SetSpamCustomFieldOnSpamInTicketSubjectOnCreate(
    LoggedWorkflow, workflow_name=WorkflowReference.SET_SPAM_CUSTOM_FIELD_ON_SPAM_IN_TICKET_SUBJECT_ON_CREATE
):
    @classmethod
    def get_activities(cls) -> Sequence[Callable[..., Awaitable[Any]]]:
        config: Config = AppConfig.get()
        rt_client = RTClient(config.rt)
        rt = RTCommonActions(rt_client)
        general = CommonConditions(rt_client)
        temporal_actions = TemporalCommonActions(config.temporal)
        return [*rt.get_activities(), *general.get_activities(), *temporal_actions.get_activities()]

    @workflow.run
    async def run(self, transaction: TransactionStruct) -> None:
        self.log_workflow()
        config = AppConfig.get()
        if await workflow.execute_activity(
            CommonConditions.has_keyword_in_subject,
            args=("SPAM", transaction),
            retry_policy=config.temporal.retry_policy,
            start_to_close_timeout=config.temporal.activity_timeout,
        ):
            await workflow.execute_activity(
                RTCommonActions.set_custom_field,
                args=("Category", "Spam", transaction),
                retry_policy=config.temporal.retry_policy,
                start_to_close_timeout=config.temporal.activity_timeout,
            )
        elif config.temporal.allow_internal_cancels:
            await workflow.execute_activity(
                TemporalCommonActions.cancel_workflow,
                args=(workflow.info().workflow_id, workflow.info().task_queue),
                retry_policy=config.temporal.retry_policy,
                start_to_close_timeout=config.temporal.activity_timeout,
            )
